/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (get_attr_type (insn) == TYPE_LDDW)
        {
	  return 16 /* 0x10 */;
        }
      else
        {
	  return 8;
        }

    default:
      return 8;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (get_attr_type (insn) == TYPE_LDDW)
        {
	  return 16 /* 0x10 */;
        }
      else
        {
	  return 8;
        }

    default:
      return 8;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 38:  /* *movdf */
    case 37:  /* *movsf */
    case 36:  /* *movdi */
    case 35:  /* *movsi */
    case 34:  /* *movhi */
    case 33:  /* *movqi */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_LDX;
        }
      else if (((1ULL << which_alternative) & 0x6ULL))
        {
	  return TYPE_ALU;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_STX;
        }
      else
        {
	  return TYPE_ST;
        }

    case 26:  /* zero_extendqidi2 */
    case 25:  /* zero_extendhidi2 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return TYPE_ALU;
        }
      else
        {
	  return TYPE_LDX;
        }

    case 27:  /* zero_extendsidi2 */
    case 28:  /* *extendsidi2 */
    case 29:  /* extendhidi2 */
    case 30:  /* extendqidi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ALU;
        }
      else
        {
	  return TYPE_LDX;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      return TYPE_MULTI;

    case 48:  /* *branch_on_si */
    case 49:  /* *branch_on_di */
    case 50:  /* jump */
    case 51:  /* exit */
    case 52:  /* call_internal */
    case 53:  /* call_value_internal */
    case 54:  /* sibcall */
      return TYPE_JMP;

    case 55:  /* ldindb */
    case 56:  /* ldindh */
    case 57:  /* ldindw */
    case 58:  /* ldinddw */
    case 59:  /* ldabsb */
    case 60:  /* ldabsh */
    case 61:  /* ldabsw */
    case 62:  /* ldabsdw */
      return TYPE_LD;

    case 45:  /* bswaphi2 */
    case 46:  /* bswapsi2 */
    case 47:  /* bswapdi2 */
      return TYPE_END;

    case 2:  /* addsi3 */
    case 4:  /* subsi3 */
    case 6:  /* negsi2 */
    case 8:  /* mulsi3 */
    case 10:  /* *mulsidi3_zeroextend */
    case 11:  /* udivsi3 */
    case 13:  /* divsi3 */
    case 15:  /* umodsi3 */
    case 17:  /* modsi3 */
    case 19:  /* andsi3 */
    case 21:  /* iorsi3 */
    case 23:  /* xorsi3 */
    case 39:  /* ashrsi3 */
    case 41:  /* ashlsi3 */
    case 43:  /* lshrsi3 */
      return TYPE_ALU32;

    case 63:  /* atomic_fetch_addsi */
    case 64:  /* atomic_fetch_adddi */
    case 65:  /* atomic_fetch_andsi */
    case 66:  /* atomic_fetch_anddi */
    case 67:  /* atomic_fetch_orsi */
    case 68:  /* atomic_fetch_ordi */
    case 69:  /* atomic_fetch_xorsi */
    case 70:  /* atomic_fetch_xordi */
    case 71:  /* atomic_exchangesi */
    case 72:  /* atomic_exchangedi */
    case 73:  /* atomic_compare_and_swapsi_1 */
    case 74:  /* atomic_compare_and_swapdi_1 */
      return TYPE_UNKNOWN;

    default:
      return TYPE_ALU;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 3;
